Package: RPostgreSQL
Version: 0.7-7
Date: 2024-09-30
Title: R Interface to the 'PostgreSQL' Database System
Maintainer: Tomoaki Nishiyama <tomoaki@sci.u-toyama.ac.jp>
Description: Database interface and 'PostgreSQL' driver for 'R'.
 This package provides a Database Interface 'DBI' compliant 
 driver for 'R' to access 'PostgreSQL' database systems.  
 In order to build and install this package from source, 'PostgreSQL' 
 itself must be present your system to provide 'PostgreSQL' functionality 
 via its libraries and header files. These files are provided as
 'postgresql-devel' package under some Linux distributions.
 On 'macOS' and 'Microsoft Windows' system the attached 'libpq' library source will be used.
LazyLoad: true
Depends: R (>= 3.4.0), methods, DBI (>= 0.3)
License: GPL-3 | file LICENSE
Copyright: Authors listed above, PostgreSQL Global Development Group,
        and The Regents of the University of California
Collate: S4R.R zzz.R PostgreSQLSupport.R dbObjectId.R PostgreSQL.R
URL: https://github.com/tomoakin/RPostgreSQL,
        https://cran.r-project.org/package=DBI,
        https://www.postgresql.org
Authors@R: c(person(given = "Joe",
                       family = "Conway",
                       role = "aut"),
                person(given = "Dirk",
                       family = "Eddelbuettel",
                       role = "aut"),
                person(given = "Tomoaki",
                       family = "Nishiyama",
                       role = c("aut", "cre"),
                       email = "tomoaki@sci.u-toyama.ac.jp"),
                person(given = c("Sameer", "Kumar"),
                       family = "Prayaga",
                       role = "aut",
                       comment = "during 2008"),
                person(given = "Neil",
                       family = "Tiffin",
                       role = "aut"))
NeedsCompilation: yes
Packaged: 2024-09-30 04:53:23 UTC; tomoaki
Author: Joe Conway [aut],
  Dirk Eddelbuettel [aut],
  Tomoaki Nishiyama [aut, cre],
  Sameer Kumar Prayaga [aut] (during 2008),
  Neil Tiffin [aut]
Repository: CRAN
Date/Publication: 2024-09-30 07:20:07 UTC
Built: R 4.4.2; aarch64--netbsd; 2026-01-01 19:25:53 UTC; unix

#!/usr/bin/env r

## Create a database
tempdb <- "tempdbase"
system(paste("createdb", tempdb))

library(RPostgreSQL)
drv <- dbDriver("PostgreSQL")
con <- dbConnect(drv, dbname=tempdb)



## Test the numeric mapping
dbSendQuery(con, "create table testnumeric (intcolumn integer, floatcolumn float);")

i <- as.integer(10)
j <- as.numeric(56.6)

sql <- paste("insert into testnumeric ",
            "values (",i, "," ,j ,") ", sep="")
res <- dbSendQuery(con, sql)


dat <- dbReadTable(con, "testnumeric")
cat("Read Numeric values\n")

## now test the types of the colums we got
stopifnot( class(dat[,1]) == "integer" )
stopifnot( class(dat[,2]) == "numeric" )
cat("GOOD -- all numeric types are as expected\n")

## and test the values
stopifnot( identical( dat[1,1], i))
stopifnot( identical( dat[1,2], j))
cat("GOOD -- all numeric values are as expected\n")




## Test the logical mapping
dbSendQuery(con,"create table testlogical (col1 boolean, col2 boolean)")

i <- as.logical(TRUE)
j <- as.logical(FALSE)

sql <- paste("insert into testlogical ",
            "values (",i, "," ,j ,") ", sep="")
res <- dbSendQuery(con, sql);

dat <- dbReadTable(con, "testlogical")
cat("Read Logical values\n")

## now test the types of the colums we got
stopifnot( class(dat[,1]) == "logical" )
stopifnot( class(dat[,2]) == "logical" )
cat("GOOD -- all logical types are as expected\n")

## and test the values
stopifnot( identical( dat[1,1], i))
stopifnot( identical( dat[1,2], j))
cat("GOOD -- all logical values are as expected\n")




## Test the character mapping
dbSendQuery(con,"create table testchar (code char(3),city varchar(20),country text);")

i <- as.character("IN")
j <- as.character("Hyderabad")
k <- as.character("India")


sql <- paste("insert into testchar ",
            "values ('",i,"' , '",j ,"' , '",k,"') ", sep="")
res <- dbSendQuery(con, sql);

dat <- dbReadTable(con, "testchar")
cat("Read Character values\n")

## now test the types of the colums we got
stopifnot( class(dat[,1]) == "character" )
stopifnot( class(dat[,2]) == "character" )
stopifnot( class(dat[,3]) == "character" )
cat("GOOD -- all character types are as expected\n")


## and test the values
##stopifnot( identical( dat[1,1], i))
stopifnot( identical( dat[1,2], j))
stopifnot( identical( dat[1,3], k))
cat("GOOD -- all character values are as expected\n")


dbDisconnect(con)
dbUnloadDriver(drv)

system(paste("dropdb", tempdb))

cat("DONE\n") 

#!/usr/bin/env r

cat("Testing the working of Transaction Management\n")

## Create a database
tempdb <- "tempdbase123"
system(paste("createdb", tempdb))

library(RPostgreSQL)
drv <- dbDriver("PostgreSQL")
con <- dbConnect(drv, dbname=tempdb)

## Test the numeric mapping
dbSendQuery(con, "create table book123list (intcolumn integer, floatcolumn float);")

## insert four rows into the table
dbSendQuery(con, "insert into book123list values(12,13.21);")
dbSendQuery(con, "insert into book123list values(50,11.21);")
dbSendQuery(con, "insert into book123list values(100,200.1);")
dbSendQuery(con, "insert into book123list values(5,3.56);")

cat("Table book123list contains the following records\n")
dbGetQuery(con, "select * from book123list")

cat("Test Run 1:\n")

dbBeginTransaction(con);
cat("Begin Transaction\n")
rs <- dbSendQuery(con, "DELETE from book123list WHERE intcolumn >= 50");
dbClearResult(rs);
cat("After Deletion\n");
dbGetQuery(con, "select * from book123list")
dbRollback(con)
cat("After Rolling back\n")

cat("Table book123list contains the following records\n")
dbGetQuery(con, "select * from book123list")

cat("Test Run 2:\n")

dbBeginTransaction(con);
cat("Begin Transaction\n")
dbGetQuery(con, "select * from book123list")[1, ];
rs <- dbSendQuery(con, "DELETE from book123list WHERE intcolumn >= 50");
dbClearResult(rs);
cat("After Deletion\n");
dbGetQuery(con, "select * from book123list")
dbCommit(con);
cat("After commiting the transaction\n")
dbGetQuery(con, "select * from book123list")

dbDisconnect(con)
dbUnloadDriver(drv)

system(paste("dropdb", tempdb))

cat("DONE\n") 

#!/usr/bin/env r

usePG <- TRUE

if (usePG) {
    cat("Using Pg\n")
    tempdb <- "pgdatetime"
    system(paste("createdb", tempdb))   # create a temp database

    suppressMessages(library(RPostgreSQL))
    drv <- dbDriver("PostgreSQL")
    con <- dbConnect(drv, dbname=tempdb)

} else {
    cat("Using SQLite\n")
    tempdb <- "/tmp/tempdb.sqlite"          # assumed to not exist
    suppressMessages(library(RSQLite))
    drv <- dbDriver("SQLite")
    if (file.exists(tempdb))
        unlink(tempdb)
    con <- dbConnect(drv, tempdb)
}


sql <- "create table foo (i integer, r real, t text)"
res <- dbSendQuery(con, sql)
cat("Created table\n")

i <- as.integer(11)
r <- as.numeric(22.22)
txt <- as.character("blim blom")

sql <- paste("insert into foo ",
             "values (",
             i, ",",
             r, ", '",
             txt, "') ", sep="")
res <- dbSendQuery(con, sql)
cat("Wrote values\n")

df <- dbReadTable(con, "foo")
cat("Read values\n")

## now test the types of the colums we got
stopifnot( class(df[,1]) == "integer" )
stopifnot( class(df[,2]) == "numeric" )
stopifnot( class(df[,3]) == "character" )
cat("GOOD -- all types are as expected\n")

## and test the values
stopifnot( identical( df[1,1], i))
stopifnot( identical( df[1,2], r))
stopifnot( identical( df[1,3], txt))
cat("GOOD -- all values are as expected\n")

if (usePG) {
    dbDisconnect(con)
    dbUnloadDriver(drv)
    system(paste("dropdb", tempdb))
} else {
    dbDisconnect(con)
    dbUnloadDriver(drv)
    unlink(tempdb)
}

cat("DONE\n")

#!/usr/bin/env r

## assign a basic time type
now <- Sys.time()

basicTypeTests <- function() {

    ## print invokes a conversion to char for 'display' even though the type is really POSIXct
    print(now)
    print(class(now))

    ## we can also convert to char() implicitly
    print(format(now))
    print(class(format(now)))

    ## but what is important is that 'now' is still a time type
    ## that we can 'compute'
    print(now)
    print(now + 60)  ## one minute later
    twomin <- now + 120
    print(as.numeric(now))

    ## and the time is even stored at millisecond granularity!!
    options("digits.secs"=7)		## need to tell R we want sub-second display up to 7 digits
    print(now)				## and now we do
    print(as.numeric(now), digits=16)	## same milli/microseconds here


    ## you can also go the other way and parse a datetime object from a char vector
    then <- strptime("2008-07-01 14:15:16", "%Y-%m-%d %H:%M:%S")
    print(then)
    print(class(then))
    ## and we can convert this from its default 'POSIXlt' ('long type) representation to 'POSIXct' ('compact type')
    then <- as.POSIXct(then)
    print(then)
    print(class(then))
}

dbTypeTests <- function(dateclass="timestamp without time zone") {
    cat("\n\n**** Trying with ", dateclass, "\n")
    tempdb <- "pgdatetime"
    system(paste("createdb", tempdb))   # create a temp database

    stopifnot(require(RPostgreSQL))
    drv <- dbDriver("PostgreSQL")
    con <- dbConnect(drv, dbname=tempdb)

    dbSendQuery(con, paste("create table foo (tt ", dateclass, ", zz integer);", sep=""))
    dbSendQuery(con, "insert into foo values('2008-07-01 14:15:16.123', 1);")

    dbSendQuery(con, paste("insert into foo values('", format(now), "', 2);", sep=""))

    res <- dbReadTable(con, "foo")  ## fails with 'RS-DBI driver warning: (unrecognized PostgreSQL field type 1184 in column 0)'
    print(res)

    ##res <- dbSendQuery(con, "select to_char(tt, 'YYYY-MM-DD HH24:MI:SS.US TZ') as character from foo;")
    res <- dbSendQuery(con, "select tt from foo;")
    data <- fetch(res, n=-1)
    #data <- dbGetQuery(con, "select tt from foo;")
    print(dbColumnInfo(res))
    ##times <- strptime(data[,1], "%Y-%m-%d %H:%M:%OS")
    times <- data[,1]
    print(times)
    print(class(times[1]))

    print(diff(times))	## yes we can compute on date times

    dbDisconnect(con)

    system(paste("dropdb", tempdb))   # create a temp database
}

dbTypeTests()
dbTypeTests("timestamp")
dbTypeTests("timestamp with time zone")
dbTypeTests("date")
#dbTypeTests("time with time zone")
#dbTypeTests("time without time zone")

#!/usr/bin/r

suppressMessages({
    library(RODBC)
    library(RPostgreSQL)
})

testTimeData <- function(tt = "date") {

    createTempTable(tt)

    channel <- odbcConnect("beancounter")
    odbcres <- sqlQuery(channel, "select * from timetest")
    close(channel)

    con <- dbConnect( dbDriver("PostgreSQL"), dbname="beancounter")
    pgres <- dbGetQuery(con, "select * from timetest")
    dbDisconnect(con)

    removeTempTable()

    cat("\nFor type='", tt, "'\nODBC returns ", format(odbcres[1,1]), " class ", class(odbcres[1,1]),
        "\nRPostgreSQL returns ", format(pgres[1,1]), " class ", class(pgres[1,1]), "\n", sep="")
}

createTempTable <- function(tt) {
    system(paste("psql beancounter -c \"create table timetest ( d1", tt, ")\" >/dev/null"))
    system("psql beancounter -c \"insert into timetest values( \'now\' )\" >/dev/null")
}

removeTempTable <- function() {
    system("psql beancounter -c \"drop table timetest\" >/dev/null")
}

testTimeData("date")
testTimeData("timestamp with time zone")
testTimeData("timestamp without time zone")
testTimeData("time with time zone")
testTimeData("time without time zone")

#!/bin/sh

set -e

dbname="pgtemp"

createdb ${dbname} 
echo "Created ${dbname}"

cat <<EOF | R --slave
  library(RPostgreSQL)
  data(trees)
  drv <- dbDriver("PostgreSQL")
  con <- dbConnect(drv, dbname="${dbname}")
  res <- dbWriteTable(con, "trees", trees)
  dbDisconnect(con)
EOF

psql ${dbname} -c "select * from trees;" 

dropdb ${dbname}
echo "Deleted ${dbname}"
